# Type 2 Network
#
# Legenda: Sn=sourceN, CAn=CellAsseblyN, + means ignition, - means hinibition, 1/2 means half connections 
# 
# S0+CA0+CA1
# CA1-CA0
# The output should show an initial burst in state0, then state1 coming on,
# shutting 0 down and persisting until the end of the run.

#---STEP 1
from FSA_BrainScaleS import FSA_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
FSABSS = FSA_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

FSABSS.brainScalesHeader()
duration = 500.0

#SETUP NETWORK
pop = FSABSS.allocateNeurons(40)
FSABSS.printParameters(pop)
pop.record()
#pynn.PopulationView(pop, [5]).record_v()
#pynn.PopulationView(pop, [15]).record_v()

cAProjections = []
cAProjections = cAProjections + [FSABSS.makeCA(pop,0)]
cAProjections = cAProjections + [FSABSS.makeCA(pop,1)]

excSpikeTimes0 = [100]
spikeSources0 = FSABSS.getSpikeSources(excSpikeTimes0)

sourceProjections = []
sourceProjections = sourceProjections + [FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop,0)]


fullProjections = []
fullProjections = fullProjections + [FSABSS.stateStartsState(pop,0,pop,1)]

stopProjections = []
stopProjections = stopProjections + [FSABSS.stateStopsState(pop,1,pop,0)]

FSABSS.brainScalesMap(pop,[297])
FSABSS.runSim(duration) # run pynn after mapping

#print FSABSS.marocco.stats
#print FSABSS.marocco.stats.getSynapses()
#print FSABSS.marocco.stats.getSynapseLoss()

#Set the hardware weights and run properly.
FSABSS.setHardwareWeights(cAProjections,sourceProjections,[],fullProjections,
                          stopProjections,[],[])

FSABSS.brainScalesFooter()
FSABSS.runSim(duration)
#np.savetxt("output/test_type2_withFSAClass_membrane_w{}.txt".format(fullWeight), pop.get_v())
np.savetxt("output/test2StateSpikes.txt", pop.getSpikes())
FSABSS.resetSim()

