# Type 2 Network
#
# Legenda: Sn=sourceN, CAn=CellAsseblyN, + means ignition, - means hinibition, 1/2 means half connections 
# 
# S0+CA0-1/2-CA1
# The output should show state 0 persisting for the duration of the run, with
# no firing in state 1.

#---STEP 1
from FSA_BrainScaleS import FSA_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
FSABSS = FSA_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

FSABSS.brainScalesHeader()
duration = 500.0

#SETUP NETWORK
pop = FSABSS.allocateNeurons(40)
FSABSS.printParameters(pop)
pop.record()
#pynn.PopulationView(pop, [5]).record_v()
#pynn.PopulationView(pop, [15]).record_v()

cAProjections = []
cAProjections = cAProjections + [FSABSS.makeCA(pop,0)]
cAProjections = cAProjections + [FSABSS.makeCA(pop,1)]

excSpikeTimes0 = [100]
spikeSources0 = FSABSS.getSpikeSources(excSpikeTimes0)

sourceProjections = []
sourceProjections = sourceProjections + [FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop,0)]

halfProjections = []
halfProjections = halfProjections + [FSABSS.stateHalfStartsState(pop,0,pop,1)]

FSABSS.brainScalesMap(pop,[297])
FSABSS.runSim(10) # run pynn after mapping

#print FSABSS.marocco.stats
#print FSABSS.marocco.stats.getSynapses()
#print FSABSS.marocco.stats.getSynapseLoss()

#Set the hardware weights and run properly.
FSABSS.setHardwareWeights(cAProjections,sourceProjections,halfProjections,[],
                          [],[],[])

FSABSS.brainScalesFooter()
FSABSS.runSim(duration)
np.savetxt("output/testHalfSpikes.txt", pop.getSpikes())
FSABSS.resetSim()

