# Type 2 Network
#
# Legenda: Sn=sourceN, CAn=CellAsseblyN, + means ignition, - means hinibition, 1/2 means half connections 
# 
# S0+CA0-1/2-CA1

#---STEP 1
from FSA_BrainScaleS import FSA_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
timesToRun = 2
epochLength = 1000
FSABSS = FSA_BrainScaleS()
duration = epochLength*timesToRun

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

FSABSS.brainScalesHeader()

#SETUP NETWORK
pop = FSABSS.allocateNeurons(40)
FSABSS.printParameters(pop)
pop.record()

cAProjections = []
cAProjections = cAProjections + [FSABSS.makeCA(pop,0)]
cAProjections = cAProjections + [FSABSS.makeCA(pop,1)]

excSpikeTimes0 = []
inhSpikeTimes0 = []
for epoch in range (0,timesToRun):
    excSpikeTimes0 = excSpikeTimes0 + [(epochLength*epoch)+100]
    for stopSpikes in range (0,45):
        inhSpikeTimes0 = inhSpikeTimes0 + [(epochLength*epoch)+300+(stopSpikes*10)]

spikeSources0 = FSABSS.getSpikeSources(excSpikeTimes0)
spikeSources1 = FSABSS.getSpikeSources(inhSpikeTimes0)

sourceProjections = []
sourceProjections = sourceProjections + [FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop,0)]


halfProjections = []
halfProjections = halfProjections + [FSABSS.stateHalfStartsState(pop,0,pop,1)]

sourceStopProjections = []
sourceStopProjections = sourceStopProjections+ [FSABSS.turnOffStateFromSpikeSource(spikeSources1,pop,0)]
sourceStopProjections = sourceStopProjections+ [FSABSS.turnOffStateFromSpikeSource(spikeSources1,pop,1)]


FSABSS.brainScalesMap(pop,[297])
FSABSS.runSim(10) # run pynn after mapping

#Set the hardware weights and run properly.
FSABSS.setHardwareWeights(cAProjections,sourceProjections,halfProjections,[],
                          [],sourceStopProjections,[])

#undone
#sourceStopWeight = int(FSABSS.sourceInhibWeight)
#FSABSS.setBrainScaleSWt(Projections_Source1offCA0,sourceStopWeight)
#FSABSS.setBrainScaleSWt(Projections_Source1offCA1,sourceStopWeight)

FSABSS.brainScalesFooter()
FSABSS.runSim(duration)
np.savetxt("output/testMultHalfSpikes.txt", pop.getSpikes())
FSABSS.resetSim()

