# parse left or right.  
# set input (left or right) by setting source1.  Search for selct.
# output should be one word spike, and a transition to the first state (from
# left) or the second state (right) in the state spikes.

#---STEP 1
from parseBSClass import parser_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
parserObj = parser_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

parserObj.FSABSS.brainScalesHeader()
duration = 500.0

#####SETUP NETWORK
StartState = 0
RightFinalState = 1
LeftFinalState = 2
RightWord = 0
LeftWord = 1

#Allocate Neurons 
numStates = 3
numWords = 2
statePops = parserObj.makePopulations(numStates)
statePop = statePops[0]
wordPops = parserObj.makePopulations(numWords)
wordPop = wordPops[0]

statePop.record()
wordPop.record()

parserObj.makeCAs(statePops,numStates)
parserObj.makeCAs(wordPops,numWords)

excSpikeTimes0 = [100]
spikeSources0 = parserObj.FSABSS.getSpikeSources(excSpikeTimes0)

excSpikeTimes1 = [300]
spikeSources1 = parserObj.FSABSS.getSpikeSources(excSpikeTimes1)

sourceProjections = []
sourceProjections = sourceProjections + [parserObj.FSABSS.turnOnStateFromSpikeSource(spikeSources0,statePop,StartState)]

#Select word comment out RightWord or leftWord
#sourceProjections = sourceProjections + [parserObj.FSABSS.turnOnStateFromSpikeSource(spikeSources1,wordPop,RightWord)] #careful with words > 2
sourceProjections = sourceProjections + [parserObj.FSABSS.turnOnStateFromSpikeSource(spikeSources1,wordPop,LeftWord)] #careful with words > 2

parserObj.addTransition(StartState,RightFinalState,RightWord,statePops,wordPops)
parserObj.addTransition(StartState,LeftFinalState,LeftWord,statePops,wordPops)

parserObj.FSABSS.brainScalesMap(statePop,[297])
parserObj.FSABSS.brainScalesMap(wordPop,[296])
parserObj.FSABSS.runSim(10) # run pynn after mapping

#Set the hardware weights and run properly.
parserObj.setHardwareWeights(sourceProjections)

#parserObj.FSABSS.setHardwareWeights(parserObj.CAProjections,
#                                    sourceProjections,
#                                    parserObj.halfProjections,[],
#                                    parserObj.stopProjections,[],[])

parserObj.FSABSS.brainScalesFooter()
parserObj.FSABSS.runSim(duration)
np.savetxt("output/lRStateSpikes.txt", statePop.getSpikes())
np.savetxt("output/lRWordSpikes.txt", wordPop.getSpikes())
parserObj.FSABSS.resetSim()

