from FSA_BrainScaleS import FSA_BrainScaleS

class parser_BrainScaleS: 
    
    def __init__(self):
        self.FSABSS = FSA_BrainScaleS()
        self.CAProjections = []
        self.halfProjections = []
        self.stopProjections = []
        
    def makePopulations(self,numStates):
        populations = []
        numPopulations = numStates/3 #we can stick 3 CAs on a hicann
        if ((numStates%3) != 0):
            numPopulations = numPopulations + 1
        for popNum in range (0,numPopulations):
            newPop = self.FSABSS.allocateNeurons(self.FSABSS.CA_SIZE*3)
            populations = populations + [newPop]

        return populations

    def makeCAs(self,populations,numStates):
        currentPopNumber = 0
        for CANumber in range (0,numStates):
            CAPop = CANumber/3
            CAOffset = CANumber%3

            self.CAProjections = self.CAProjections + [
                    self.FSABSS.makeCA(populations[CAPop],CAOffset)]

    def addTransition(self,fromState,toState,fromWord,statePopulations,
                      wordPopulations):

        fromPop = fromState/3
        fromPopOffset = fromState%3
        toPop = toState/3
        toPopOffset = toState%3
        wordPop = fromWord/3
        wordOffset = fromWord%3

        self.halfProjections = self.halfProjections + [
            self.FSABSS.stateHalfStartsState(
            statePopulations[fromPop],fromPopOffset,
            statePopulations[toPop],toPopOffset)]
        self.halfProjections = self.halfProjections + [
            self.FSABSS.stateHalfStartsState(
            wordPopulations[wordPop],wordOffset,
            statePopulations[toPop],toPopOffset)]

        self.stopProjections = self.stopProjections + [
            self.FSABSS.stateStopsState(
            statePopulations[toPop],toPopOffset,
            statePopulations[fromPop],fromPopOffset)]
        self.stopProjections = self.stopProjections + [
            self.FSABSS.stateStopsState(
            statePopulations[toPop],toPopOffset,
            wordPopulations[wordPop],wordOffset)]

    def setHardwareWeights(self,sourceProjections):
        self.FSABSS.setHardwareWeights(self.CAProjections,sourceProjections,
                                       self.halfProjections,[],
                                       self.stopProjections,[],[])
