#Parse the sentence right.  This should go from the start state to 
#the final state on presentation of the word. 

#---STEP 1
from parseBSClass import parser_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
parserObj = parser_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

parserObj.FSABSS.brainScalesHeader()
duration = 500.0

#####SETUP NETWORK
StartState = 0
RightFinalState = 1
RightWord = 0

#Allocate Neurons 
numStates = 2
numWords = 1
statePops = parserObj.makePopulations(numStates)
statePop = statePops[0]
wordPops = parserObj.makePopulations(numWords)
wordPop = wordPops[0]
#parserObj.FSABSS.printParameters(statePop)
statePop.record()
wordPop.record()

parserObj.makeCAs(statePops,numStates)
parserObj.makeCAs(wordPops,numWords)

excSpikeTimes0 = [100]
spikeSources0 = parserObj.FSABSS.getSpikeSources(excSpikeTimes0)

excSpikeTimes1 = [300]
spikeSources1 = parserObj.FSABSS.getSpikeSources(excSpikeTimes1)

sourceProjections = []
sourceProjections = sourceProjections + [parserObj.FSABSS.turnOnStateFromSpikeSource(spikeSources0,statePop,StartState)]
sourceProjections = sourceProjections + [parserObj.FSABSS.turnOnStateFromSpikeSource(spikeSources1,wordPop,RightWord)] #careful with words > 2

parserObj.addTransition(StartState,RightFinalState,RightWord,statePops,wordPops)

#halfProjections = []
#halfProjections = halfProjections + [parserObj.FSABSS.stateHalfStartsState(statePop,0,statePop,2)]
#halfProjections = halfProjections + [parserObj.FSABSS.stateHalfStartsState(wordPop,0,statePop,2)]

#stopProjections = []
#stopProjections = stopProjections + [parserObj.FSABSS.stateStopsState(statePop,2,statePop,0)]
#stopProjections = stopProjections + [parserObj.FSABSS.stateStopsState(statePop,2,wordPop,0)]

parserObj.FSABSS.brainScalesMap(statePop,[297])
parserObj.FSABSS.brainScalesMap(wordPop,[296])
parserObj.FSABSS.runSim(10) # run pynn after mapping

#Set the hardware weights and run properly.
parserObj.FSABSS.setHardwareWeights(parserObj.CAProjections,
                                    sourceProjections,
                                    parserObj.halfProjections,[],
                                    parserObj.stopProjections,[],[])
#parserObj.FSABSS.setHardwareWeights(cAProjections,sourceProjections,
#                                    halfProjections,[],stopProjections,[],[])

parserObj.FSABSS.brainScalesFooter()
parserObj.FSABSS.runSim(duration)
np.savetxt("output/tRStateSpikes.txt", statePop.getSpikes())
np.savetxt("output/tRWordSpikes.txt", wordPop.getSpikes())
parserObj.FSABSS.resetSim()

