# Three set cascade.
# No persistence so it doesn't cascade.

#---STEP 1
from timerClass import timer_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
timerObj = timer_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

timerObj.FSABSS.brainScalesHeader()
duration = 800.0

#SETUP NETWORK
timerPops = timerObj.makeStopTimer(3)
pop = timerPops[0]

pop.record()

excSpikeTimes0 = [100]
spikeSources0 = timerObj.FSABSS.getSpikeSources(excSpikeTimes0)

sourceProjections = []
sourceProjections = sourceProjections + [timerObj.FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop,0)]

timerObj.FSABSS.brainScalesMap(pop,[236])
timerObj.FSABSS.runSim(10) # run pynn after mapping


#Set the hardware weights and run properly.
timerObj.setHardwareWeights(sourceProjections)

timerObj.FSABSS.brainScalesFooter()
timerObj.FSABSS.runSim(duration)
np.savetxt("output/test3StateSpikes.txt", pop.getSpikes())
timerObj.FSABSS.resetSim()

