#---STEP 1
from timerClass import timer_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
timerObj = timer_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

timerObj.FSABSS.brainScalesHeader()
duration = 800.0

#SETUP NETWORK
timerPops = timerObj.makeStopTimer(4)
pop0 = timerPops[0]
pop1 = timerPops[1]

pop0.record()
pop1.record()

excSpikeTimes0 = [100]
spikeSources0 = timerObj.FSABSS.getSpikeSources(excSpikeTimes0)

sourceProjections = []
sourceProjections = sourceProjections + [timerObj.FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop0,0)]

timerObj.FSABSS.brainScalesMap(pop0,[234])
timerObj.FSABSS.brainScalesMap(pop1,[235])
timerObj.FSABSS.runSim(10) # run pynn after mapping


#Set the hardware weights and run properly.
timerObj.setHardwareWeights(sourceProjections)

timerObj.FSABSS.brainScalesFooter()
timerObj.FSABSS.runSim(duration)
np.savetxt("output/test4State0Spikes.txt", pop0.getSpikes())
np.savetxt("output/test4State1Spikes.txt", pop1.getSpikes())
timerObj.FSABSS.resetSim()

