#---STEP 1
from timerClass import timer_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
timerObj = timer_BrainScaleS()

logger = pylogging.get("guidebook")
init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

timerObj.FSABSS.brainScalesHeader()
duration = 800.0

#SETUP NETWORK 
timerPops = timerObj.makeLoopTimer(7)
pop0 = timerPops[0]
pop1 = timerPops[1]
pop2 = timerPops[2]
timerObj.FSABSS.printParameters(pop0)
pop0.record()
pop1.record()
pop2.record()

excSpikeTimes0 = [100]
spikeSources0 = timerObj.FSABSS.getSpikeSources(excSpikeTimes0)

sourceProjections = []
sourceProjections = sourceProjections + [timerObj.FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop0,0)]

timerObj.FSABSS.brainScalesMap(pop0,[236])
timerObj.FSABSS.brainScalesMap(pop1,[237])
timerObj.FSABSS.brainScalesMap(pop2,[269])
timerObj.FSABSS.runSim(10) # run pynn after mapping

#Set the hardware weights and run properly.
timerObj.setHardwareWeights(sourceProjections)
#timerObj.FSABSS.setHardwareWeights(timerObj.CAProjections,
#                                   sourceProjections,[],[],
#                                   timerObj.stopProjections,[],
#                                   timerObj.otherProjections)

timerObj.FSABSS.brainScalesFooter()
timerObj.FSABSS.runSim(duration)
np.savetxt("output/test7Loop0Spikes.txt", pop0.getSpikes())
np.savetxt("output/test7Loop1Spikes.txt", pop1.getSpikes())
np.savetxt("output/test7Loop2Spikes.txt", pop2.getSpikes())
timerObj.FSABSS.resetSim()

