# Three set cascade.
# No persistence so it doesn't cascade.

#---STEP 1
from FSA_BrainScaleS import FSA_BrainScaleS

import os
import sys
import numpy as np

from pysthal.command_line_util import init_logger
import pylogging

#---STEP 2 main--
FSABSS = FSA_BrainScaleS()

logger = pylogging.get("guidebook")

init_logger("WARN", [
    ("guidebook", "DEBUG"),
    ("marocco", "DEBUG"),
    #("Calibtic", "DEBUG"),
    #("sthal", "INFO")
])

FSABSS.brainScalesHeader()
duration = 2000.0

#SETUP NETWORK
pop = FSABSS.allocateNeurons(60)
FSABSS.printParameters(pop)
pop.record()
#pynn.PopulationView(pop, [5]).record_v()
#pynn.PopulationView(pop, [15]).record_v()

excSpikeTimes0 = [100,600,1100,1600]
spikeSources0 = FSABSS.getSpikeSources(excSpikeTimes0)


cAProjections = []
cAProjections = cAProjections + [FSABSS.makeCA(pop,0)]
cAProjections = cAProjections + [FSABSS.makeCA(pop,1)]


lastSelfWeight = 2
lastStateSelfProjections = []
lastStateSelfProjections = lastStateSelfProjections +  [FSABSS.stateStimulatesState(pop,2,pop,2,6,lastSelfWeight)]

otherProjections = []
otherProjections = otherProjections + [[lastStateSelfProjections,lastSelfWeight]]

sourceProjections = []
sourceProjections = sourceProjections + [FSABSS.turnOnStateFromSpikeSource(spikeSources0,pop,0)]


fullProjections = []
fullProjections = fullProjections + [FSABSS.stateStartsState(pop,0,pop,1)]
fullProjections = fullProjections + [FSABSS.stateStartsState(pop,1,pop,2)]

stopProjections = []
stopProjections = stopProjections + [FSABSS.stateStopsState(pop,1,pop,0)]

stopProjections = []
stopProjections = stopProjections + [FSABSS.stateStopsState(pop,1,pop,0)]

strongStopWeight = 15
hardStopProjections = []  
hardStopProjections = hardStopProjections + [FSABSS.stateInhibitsState(pop,2,pop,1,strongStopWeight)]
otherProjections = otherProjections + [[hardStopProjections,strongStopWeight]]

FSABSS.brainScalesMap(pop,[236])
FSABSS.runSim(10) # run pynn after mapping

#Set the hardware weights and run properly.

FSABSS.brainScalesFooter()
FSABSS.runSim(duration)
np.savetxt("output/testMult3StateSpikes.txt", pop.getSpikes())
FSABSS.resetSim()

