from FSA_BrainScaleS import FSA_BrainScaleS

class timer_BrainScaleS: 
    
    def __init__(self):
        self.FSABSS = FSA_BrainScaleS()
        self.CAProjections = []
        self.fullProjections = []
        self.stopProjections = []
        self.otherProjections = []
        
    def makePopulations(self,numStates):
        populations = []
        numPopulations = numStates/3 #we can stick 3 CAs on a hicann
        if ((numStates%3) != 0):
            numPopulations = numPopulations + 1
        for popNum in range (0,numPopulations):
            newPop = self.FSABSS.allocateNeurons(self.FSABSS.CA_SIZE*3)
            populations = populations + [newPop]

        return populations

    def makeCAs(self,populations,numStates):
        currentPopNumber = 0
        for CANumber in range (0,numStates):
            CAPop = CANumber/3
            CAOffset = CANumber%3

            self.CAProjections = self.CAProjections + [
                    self.FSABSS.makeCA(populations[CAPop],CAOffset)]
            print 'george', CAOffset

    def makeVWeakCA(self,populations,numStates):
        lastSelfWeight = 2
        numSynapses = 6

        numPopulations = numStates/3 #we can stick 3 CAs on a hicann
        stateNumber = (numStates-1)%3

        lastStateSelfProjections = [self.FSABSS.stateStimulatesState(
            populations[numPopulations-1],stateNumber,
            populations[numPopulations-1],stateNumber,numSynapses,
            lastSelfWeight)]

        self.otherProjections = self.otherProjections + [
            [lastStateSelfProjections,lastSelfWeight]]

    def makeForwardSynapses(self,populations,numStates):
        currentPopNumber = 0
        for forwardConnectionNumber in range (0,numStates-1):
            forwardConnectionOffset = forwardConnectionNumber%3
            print 'bart', forwardConnectionOffset
            if (forwardConnectionOffset == 2):
                forwardConnectionProjections = self.FSABSS.stateStartsState(
                    populations[currentPopNumber],2,
                    populations[currentPopNumber+1],0)
                currentPopNumber = currentPopNumber + 1
                
            #0-1 and 1-2
            else:
                forwardConnectionProjections = self.FSABSS.stateStartsState(
                    populations[currentPopNumber],forwardConnectionOffset,
                    populations[currentPopNumber],forwardConnectionOffset+1)

            self.fullProjections = self.fullProjections +  [
                forwardConnectionProjections]

    def makeStopStopSynapses(self,populations,numStates):
        currentPopNumber = 0
        for backwardConnectionNumber in range (1,numStates-1): 
            backwardConnectionOffset = backwardConnectionNumber%3
            print 'bob', backwardConnectionOffset
            if (backwardConnectionOffset) == 0:
                backwardConnectionProjections = self.FSABSS.stateStopsState(
                    populations[currentPopNumber],0,
                    populations[currentPopNumber-1],2)
                
            #2-1 and 1-0
            else:
                backwardConnectionProjections = self.FSABSS.stateStopsState(
                    populations[currentPopNumber],backwardConnectionOffset,
                    populations[currentPopNumber],backwardConnectionOffset-1)

            if (backwardConnectionOffset == 2): 
                currentPopNumber = currentPopNumber + 1

            self.stopProjections = self.stopProjections +  [
                backwardConnectionProjections]

    def makeHardLastStopSynapses(self,populations,numStates):
        strongStopWeight = 15

        numPopulations = numStates/3 #we can stick 3 CAs on a hicann
        stateNumber = (numStates-1)%3
        if (stateNumber != 2):
            numPopulations = numPopulations+1

        hardStopProjections = []  
        if (stateNumber == 0):
            hardStopProjections = hardStopProjections + [
                self.FSABSS.stateInhibitsState(populations[numPopulations-1],0,
                populations[numPopulations-2],2, strongStopWeight)]
            
        else:
            hardStopProjections = hardStopProjections + [
                self.FSABSS.stateInhibitsState(populations[numPopulations-1],
                stateNumber,populations[numPopulations-1],stateNumber-1,
                strongStopWeight)]

        self.otherProjections = self.otherProjections + [[hardStopProjections,strongStopWeight]]
        

    ###external entry point.  Take number of states for one pass timer that
    #stops on its own.  Return list of populations (3 states per pop).
    #Need to stick the populations on hicanns.
    def makeStopTimer(self,numStates):
        populations = self.makePopulations(numStates)

        self.makeCAs(populations,numStates-1)
        self.makeVWeakCA(populations,numStates)
        self.makeForwardSynapses(populations,numStates)
        self.makeStopStopSynapses(populations,numStates)
        self.makeHardLastStopSynapses(populations,numStates)
        
        return populations


    #This is the same as makeStopStopSynapses, but the last needs
    #to inhibit the penultimate as normal, and the first needs
    #to inhib the last.
    def makeLoopStopSynapses(self,populations,numStates):
        self.makeStopStopSynapses(populations,numStates)
        
        #make last inhibits penultimate
        lastPopNumber = (numStates-1)/3
        lastPopOffset = (numStates-1)%3

        if (lastPopOffset == 0):
            backwardConnectionProjections = self.FSABSS.stateStopsState(
                populations[lastPopNumber],0,
                populations[lastPopNumber-1],2)
        else:
            backwardConnectionProjections = self.FSABSS.stateStopsState(
                populations[lastPopNumber],lastPopOffset,
                populations[lastPopNumber],lastPopOffset-1)
        self.stopProjections = self.stopProjections +  [
            backwardConnectionProjections]

        #make first inhbits last
        backwardConnectionProjections = self.FSABSS.stateStopsState(
            populations[0],0,populations[lastPopNumber],lastPopOffset)

    def makeLoopForwardSynapses(self,populations,numStates):
        numForwardSynapses = 8
        forwardWeight = 3
        forwardProjections = []  

        currentPopNumber = 0
        for forwardConnectionNumber in range (0,numStates-1):
            forwardConnectionOffset = forwardConnectionNumber%3
            if (forwardConnectionOffset == 2):
                forwardProjections = forwardProjections + [
                    self.FSABSS.stateStimulatesState(
                        populations[currentPopNumber],2,
                        populations[currentPopNumber+1],0,
                        numForwardSynapses,forwardWeight)]
                currentPopNumber = currentPopNumber + 1

            #0-1 and 1-2
            else:
                forwardProjections = forwardProjections + [
                    self.FSABSS.stateStimulatesState(
                        populations[currentPopNumber],forwardConnectionOffset,
                        populations[currentPopNumber],forwardConnectionOffset+1,
                        numForwardSynapses,forwardWeight)]

        #add last to first connection
        if (forwardConnectionOffset == 2):
            forwardProjections = forwardProjections + [
                self.FSABSS.stateStimulatesState(populations[currentPopNumber],
                    0,populations[0],0,
                    numForwardSynapses,forwardWeight)]
        else:
            forwardProjections = forwardProjections + [
                self.FSABSS.stateStimulatesState(populations[currentPopNumber],
                    forwardConnectionOffset+1,populations[0],0,
                    numForwardSynapses,forwardWeight)]

        self.otherProjections = self.otherProjections + [[forwardProjections,forwardWeight]]


        
    ###external entry point
    def makeLoopTimer(self,numStates):
        populations = self.makePopulations(numStates)

        self.makeCAs(populations,numStates)
        self.makeLoopStopSynapses(populations,numStates)
        self.makeLoopForwardSynapses(populations,numStates)

        return populations

    def setHardwareWeights(self,sourceProjections):
        self.FSABSS.setHardwareWeights(self.CAProjections,sourceProjections,[],
            self.fullProjections,self.stopProjections,[],self.otherProjections)
